package com.remainsoftware.adapter.test;

import org.eclipse.e4.core.services.adapter.Adapter;

public class HumanToPersonAdapter extends Adapter {

	@Override
	public <T> T adapt(Object element, Class<T> adapterType) {
		
		System.err.println("adapting");

		if (element.getClass() == adapterType) {
			return (T) element;
		}

		if (element instanceof Human && adapterType == Person.class) {
			Human human = (Human) element;
			return (T) new Person(human.getFirstName(), human.getLastName());
		}
		return null;
	}
}
